# About Models

The model is where it all comes together in xStream. And a big subject to cover, so it has been split into a number of topics:

## [Coding with xStream](coding_intro.md)

* Explains how real-time streaming can be done from a few lines of code.
* Shows you how to work with methods and data.

## [Model arguments](model_arguments.md)

* Allows you to control the behaviour of a model while it's running.
* Learn how to create new arguments, and what their properties mean. 

## [Model events](model_events.md)

* Handle when internal arguments in a model has changed. 
* Respond to external events, such as MIDI Input or the Renoise API. 

## [Files & formats](file_formats.md)

* Easily exchangable, plain-text Lua or XML files
* How the xStream userdata folder works

> < Previous - [The User Interface](user_interface.md) &nbsp; &nbsp; | &nbsp; &nbsp; Next - [Examples](example_models.md) >







