--[[===========================================================================
Euclidean Rhythms.lua
===========================================================================]]--

return {
arguments = {
  {
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.enabled",
      ["properties"] = {
          ["display_as"] = "boolean",
      },
      ["value"] = true,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.steps",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 32,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.pulses",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 6,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "transpose",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 64,
          ["min"] = -64,
          ["zero_based"] = false,
      },
      ["value"] = 15,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "tempo",
      ["properties"] = {
          ["display_as"] = "switch",
          ["items"] = {
              "1",
              "1/2",
              "1/3",
              "1/4",
              "1/6",
          },
          ["max"] = 5,
          ["min"] = 1,
      },
      ["value"] = 4,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.offset",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 16,
          ["min"] = -16,
          ["zero_based"] = false,
      },
      ["value"] = 0,
  },
  {
      ["description"] = "makes note-on become note-off and vice versa",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.invert",
      ["properties"] = {
          ["display_as"] = "checkbox",
      },
      ["value"] = false,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.pitch",
      ["properties"] = {
          ["display_as"] = "note",
          ["max"] = 119,
          ["min"] = 0,
      },
      ["value"] = 40.291338582677,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.velocity",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 128,
          ["min"] = 0,
          ["zero_based"] = false,
      },
      ["value"] = 40.314960629921,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "a.column",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 12,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 1,
  },
  {
      ["description"] = "",
      ["linked"] = true,
      ["locked"] = false,
      ["name"] = "a.instr",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 255,
          ["min"] = 1,
          ["zero_based"] = true,
      },
      ["value"] = 1,
  },
  {
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.enabled",
      ["properties"] = {
          ["display_as"] = "boolean",
      },
      ["value"] = true,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.steps",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 32,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.pulses",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 2,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.offset",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 16,
          ["min"] = -16,
          ["zero_based"] = false,
      },
      ["value"] = 4,
  },
  {
      ["description"] = "makes note-on become note-off and vice versa",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.invert",
      ["properties"] = {
          ["display_as"] = "checkbox",
      },
      ["value"] = false,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.pitch",
      ["properties"] = {
          ["display_as"] = "note",
          ["max"] = 119,
          ["min"] = 0,
      },
      ["value"] = 61.842519685039,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.velocity",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 128,
          ["min"] = 0,
          ["zero_based"] = false,
      },
      ["value"] = 42.330708661417,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "b.column",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 12,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 2,
  },
  {
      ["description"] = "",
      ["linked"] = true,
      ["locked"] = false,
      ["name"] = "b.instr",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 255,
          ["min"] = 1,
          ["zero_based"] = true,
      },
      ["value"] = 1,
  },
  {
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.enabled",
      ["properties"] = {
          ["display_as"] = "boolean",
      },
      ["value"] = true,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.steps",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 22,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.pulses",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 4,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.offset",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 16,
          ["min"] = -16,
          ["zero_based"] = false,
      },
      ["value"] = 1,
  },
  {
      ["description"] = "makes note-on become note-off and vice versa",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.invert",
      ["properties"] = {
          ["display_as"] = "checkbox",
      },
      ["value"] = false,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = true,
      ["name"] = "phrase_idx",
      ["poll"] = "rns.selected_phrase_index",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 100,
          ["min"] = 0,
          ["zero_based"] = false,
      },
      ["value"] = 0,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.pitch",
      ["properties"] = {
          ["display_as"] = "note",
          ["max"] = 119,
          ["min"] = 0,
      },
      ["value"] = 45.913385826772,
  },
  {
      ["bind"] = "rns.selected_instrument_index_observable",
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "instr_idx",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 100,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 5,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "follow_instr",
      ["properties"] = {
          ["display_as"] = "checkbox",
      },
      ["value"] = true,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.velocity",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 128,
          ["min"] = 0,
          ["zero_based"] = false,
      },
      ["value"] = 43.338582677165,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "c.column",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 12,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 3,
  },
  {
      ["description"] = "",
      ["linked"] = true,
      ["locked"] = false,
      ["name"] = "c.instr",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 255,
          ["min"] = 1,
          ["zero_based"] = true,
      },
      ["value"] = 1,
  },
  {
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.enabled",
      ["properties"] = {
          ["display_as"] = "boolean",
      },
      ["value"] = true,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.steps",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 28,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.pulses",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 4,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.offset",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 16,
          ["min"] = -16,
          ["zero_based"] = false,
      },
      ["value"] = 0,
  },
  {
      ["description"] = "makes note-on become note-off and vice versa",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.invert",
      ["properties"] = {
          ["display_as"] = "checkbox",
      },
      ["value"] = false,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.pitch",
      ["properties"] = {
          ["display_as"] = "note",
          ["max"] = 119,
          ["min"] = 0,
      },
      ["value"] = 37.48031496063,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.velocity",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 128,
          ["min"] = 0,
          ["zero_based"] = false,
      },
      ["value"] = 38.299212598425,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "d.column",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 12,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 4,
  },
  {
      ["description"] = "",
      ["linked"] = true,
      ["locked"] = false,
      ["name"] = "d.instr",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 255,
          ["min"] = 1,
          ["zero_based"] = true,
      },
      ["value"] = 1,
  },
  {
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.enabled",
      ["properties"] = {
          ["display_as"] = "boolean",
      },
      ["value"] = false,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.steps",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 26,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.pulses",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 32,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 5,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.offset",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 16,
          ["min"] = -16,
          ["zero_based"] = false,
      },
      ["value"] = 16,
  },
  {
      ["description"] = "makes note-on become note-off and vice versa",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.invert",
      ["properties"] = {
          ["display_as"] = "checkbox",
      },
      ["value"] = false,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.pitch",
      ["properties"] = {
          ["display_as"] = "note",
          ["max"] = 119,
          ["min"] = 0,
      },
      ["value"] = 49.661417322835,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.velocity",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 128,
          ["min"] = 0,
          ["zero_based"] = false,
      },
      ["value"] = 35.275590551181,
  },
  {
      ["description"] = "",
      ["linked"] = false,
      ["locked"] = false,
      ["name"] = "e.column",
      ["properties"] = {
          ["display_as"] = "integer",
          ["max"] = 12,
          ["min"] = 1,
          ["zero_based"] = false,
      },
      ["value"] = 5,
  },
  {
      ["description"] = "",
      ["linked"] = true,
      ["locked"] = false,
      ["name"] = "e.instr",
      ["properties"] = {
          ["display_as"] = "hex",
          ["max"] = 255,
          ["min"] = 1,
          ["zero_based"] = true,
      },
      ["value"] = 1,
  },
},
presets = {
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 44.03937007874,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 34.267716535433,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 59.031496062992,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 44.346456692913,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 35.606299212598,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 53.417322834646,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = true,
      ["e.offset"] = 0,
      ["e.pitch"] = 63.716535433071,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 22.173228346457,
      ["name"] = "",
      ["phrase_idx"] = 11,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 42.165354330709,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 58.094488188976,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 46.362204724409,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = true,
      ["d.offset"] = 0,
      ["d.pitch"] = 39.669291338583,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 34.267716535433,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = true,
      ["e.offset"] = 0,
      ["e.pitch"] = 63.716535433071,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 22.173228346457,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "flex",
      ["phrase_idx"] = 1,
      ["tempo"] = 4,
      ["transpose"] = -18,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 42.165354330709,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 58.094488188976,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 46.362204724409,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = true,
      ["d.offset"] = 0,
      ["d.pitch"] = 39.669291338583,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 34.267716535433,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = true,
      ["e.offset"] = 0,
      ["e.pitch"] = 63.716535433071,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 22.173228346457,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "flex gerad",
      ["phrase_idx"] = 1,
      ["tempo"] = 1,
      ["transpose"] = -18,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 39.354330708661,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 38.299212598425,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 47.787401574803,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 59.968503937008,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 44.346456692913,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 30.92125984252,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 59.464566929134,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 0,
      ["e.pitch"] = 44.03937007874,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 32.251968503937,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "whispers",
      ["phrase_idx"] = 4,
      ["tempo"] = 3,
      ["transpose"] = -18,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 2,
      ["a.pitch"] = 39.754170708661,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 38.299212598425,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 47.787401574803,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 59.968503937008,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 44.346456692913,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 32.795275590551,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 59.464566929134,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 0,
      ["e.pitch"] = 44.976377952756,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 23.181102362205,
      ["name"] = "",
      ["phrase_idx"] = 11,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 2,
      ["a.pitch"] = 39.123287671233,
      ["a.pulses"] = 6,
      ["a.steps"] = 24,
      ["a.velocity"] = 38.417322834646,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = true,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 25.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 58.094488188976,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 40.314960629921,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 34.669291338583,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 56.44094488189,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 0,
      ["e.pitch"] = 54.346456692913,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 40.314960629921,
      ["name"] = "",
      ["phrase_idx"] = 11,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 42.165354330709,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 59.031496062992,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 46.362204724409,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 35.606299212598,
      ["d.pulses"] = 4,
      ["d.steps"] = 14,
      ["d.velocity"] = 34.267716535433,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 0,
      ["e.pitch"] = 63.716535433071,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 22.173228346457,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "off",
      ["phrase_idx"] = 4,
      ["tempo"] = 3,
      ["transpose"] = -18,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 42.165354330709,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 59.031496062992,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 46.362204724409,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 35.606299212598,
      ["d.pulses"] = 2,
      ["d.steps"] = 8,
      ["d.velocity"] = 34.267716535433,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 0,
      ["e.pitch"] = 63.716535433071,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 22.173228346457,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "on",
      ["phrase_idx"] = 4,
      ["tempo"] = 3,
      ["transpose"] = -18,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 42.165354330709,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 51.535433070866,
      ["b.pulses"] = 2,
      ["b.steps"] = 16,
      ["b.velocity"] = 56.44094488189,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 59.031496062992,
      ["c.pulses"] = 4,
      ["c.steps"] = 11,
      ["c.velocity"] = 46.362204724409,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 35.606299212598,
      ["d.pulses"] = 2,
      ["d.steps"] = 8,
      ["d.velocity"] = 34.267716535433,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 0,
      ["e.pitch"] = 63.716535433071,
      ["e.pulses"] = 5,
      ["e.steps"] = 13,
      ["e.velocity"] = 22.173228346457,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "snaps",
      ["phrase_idx"] = 4,
      ["tempo"] = 1,
      ["transpose"] = -29,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = false,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 40.291338582677,
      ["a.pulses"] = 6,
      ["a.steps"] = 32,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = false,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 61.842519685039,
      ["b.pulses"] = 2,
      ["b.steps"] = 32,
      ["b.velocity"] = 42.330708661417,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 45.913385826772,
      ["c.pulses"] = 4,
      ["c.steps"] = 22,
      ["c.velocity"] = 43.338582677165,
      ["d.column"] = 4,
      ["d.enabled"] = false,
      ["d.instr"] = 1,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 37.48031496063,
      ["d.pulses"] = 4,
      ["d.steps"] = 28,
      ["d.velocity"] = 38.299212598425,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = false,
      ["e.offset"] = 16,
      ["e.pitch"] = 49.661417322835,
      ["e.pulses"] = 5,
      ["e.steps"] = 26,
      ["e.velocity"] = 35.275590551181,
      ["follow_instr"] = true,
      ["instr_idx"] = 4,
      ["name"] = "",
      ["phrase_idx"] = 0,
      ["tempo"] = 4,
      ["transpose"] = 15,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 1,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 40.291338582677,
      ["a.pulses"] = 6,
      ["a.steps"] = 32,
      ["a.velocity"] = 40.314960629921,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 1,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 61.842519685039,
      ["b.pulses"] = 2,
      ["b.steps"] = 32,
      ["b.velocity"] = 42.330708661417,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 1,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 45.913385826772,
      ["c.pulses"] = 4,
      ["c.steps"] = 22,
      ["c.velocity"] = 43.338582677165,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 1,
      ["d.invert"] = true,
      ["d.offset"] = 0,
      ["d.pitch"] = 37.48031496063,
      ["d.pulses"] = 4,
      ["d.steps"] = 28,
      ["d.velocity"] = 38.299212598425,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 1,
      ["e.invert"] = true,
      ["e.offset"] = 16,
      ["e.pitch"] = 49.661417322835,
      ["e.pulses"] = 5,
      ["e.steps"] = 26,
      ["e.velocity"] = 35.275590551181,
      ["name"] = "",
      ["phrase_idx"] = 11,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 2,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 40.291338582677,
      ["a.pulses"] = 6,
      ["a.steps"] = 32,
      ["a.velocity"] = 0,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 2,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 45.913385826772,
      ["b.pulses"] = 2,
      ["b.steps"] = 32,
      ["b.velocity"] = 62.488188976378,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 2,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 45.913385826772,
      ["c.pulses"] = 4,
      ["c.steps"] = 22,
      ["c.velocity"] = 76.59842519685,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 2,
      ["d.invert"] = true,
      ["d.offset"] = 0,
      ["d.pitch"] = 37.48031496063,
      ["d.pulses"] = 4,
      ["d.steps"] = 28,
      ["d.velocity"] = 35.275590551181,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 2,
      ["e.invert"] = false,
      ["e.offset"] = 16,
      ["e.pitch"] = 49.661417322835,
      ["e.pulses"] = 5,
      ["e.steps"] = 26,
      ["e.velocity"] = 35.275590551181,
      ["follow_instr"] = false,
      ["instr_idx"] = 1,
      ["name"] = "GF",
      ["phrase_idx"] = 1,
      ["tempo"] = 1,
      ["transpose"] = -29,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 3,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 40.291338582677,
      ["a.pulses"] = 6,
      ["a.steps"] = 32,
      ["a.velocity"] = 0,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 3,
      ["b.invert"] = false,
      ["b.offset"] = 4,
      ["b.pitch"] = 45.913385826772,
      ["b.pulses"] = 2,
      ["b.steps"] = 32,
      ["b.velocity"] = 62.488188976378,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 3,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 45.913385826772,
      ["c.pulses"] = 4,
      ["c.steps"] = 22,
      ["c.velocity"] = 76.59842519685,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 3,
      ["d.invert"] = true,
      ["d.offset"] = 0,
      ["d.pitch"] = 37.48031496063,
      ["d.pulses"] = 4,
      ["d.steps"] = 28,
      ["d.velocity"] = 35.275590551181,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 3,
      ["e.invert"] = false,
      ["e.offset"] = 16,
      ["e.pitch"] = 49.661417322835,
      ["e.pulses"] = 5,
      ["e.steps"] = 26,
      ["e.velocity"] = 35.275590551181,
      ["follow_instr"] = true,
      ["instr_idx"] = 3,
      ["name"] = "",
      ["phrase_idx"] = 0,
      ["tempo"] = 3,
      ["transpose"] = -9,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 3,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 40.291338582677,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 0,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 3,
      ["b.invert"] = false,
      ["b.offset"] = 2,
      ["b.pitch"] = 45.913385826772,
      ["b.pulses"] = 4,
      ["b.steps"] = 16,
      ["b.velocity"] = 62.488188976378,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 3,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 45.913385826772,
      ["c.pulses"] = 4,
      ["c.steps"] = 22,
      ["c.velocity"] = 76.59842519685,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 3,
      ["d.invert"] = false,
      ["d.offset"] = 0,
      ["d.pitch"] = 37.48031496063,
      ["d.pulses"] = 4,
      ["d.steps"] = 28,
      ["d.velocity"] = 35.275590551181,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 3,
      ["e.invert"] = false,
      ["e.offset"] = 16,
      ["e.pitch"] = 49.661417322835,
      ["e.pulses"] = 5,
      ["e.steps"] = 26,
      ["e.velocity"] = 35.275590551181,
      ["follow_instr"] = true,
      ["instr_idx"] = 3,
      ["name"] = "boom",
      ["phrase_idx"] = 0,
      ["tempo"] = 3,
      ["transpose"] = -17,
  },
  {
      ["a.column"] = 1,
      ["a.enabled"] = true,
      ["a.instr"] = 3,
      ["a.invert"] = false,
      ["a.offset"] = 0,
      ["a.pitch"] = 40.291338582677,
      ["a.pulses"] = 6,
      ["a.steps"] = 16,
      ["a.velocity"] = 0,
      ["b.column"] = 2,
      ["b.enabled"] = true,
      ["b.instr"] = 3,
      ["b.invert"] = false,
      ["b.offset"] = 2,
      ["b.pitch"] = 45.913385826772,
      ["b.pulses"] = 4,
      ["b.steps"] = 16,
      ["b.velocity"] = 62.488188976378,
      ["c.column"] = 3,
      ["c.enabled"] = true,
      ["c.instr"] = 3,
      ["c.invert"] = false,
      ["c.offset"] = 1,
      ["c.pitch"] = 45.913385826772,
      ["c.pulses"] = 4,
      ["c.steps"] = 22,
      ["c.velocity"] = 76.59842519685,
      ["d.column"] = 4,
      ["d.enabled"] = true,
      ["d.instr"] = 3,
      ["d.invert"] = true,
      ["d.offset"] = 0,
      ["d.pitch"] = 37.48031496063,
      ["d.pulses"] = 4,
      ["d.steps"] = 28,
      ["d.velocity"] = 35.275590551181,
      ["e.column"] = 5,
      ["e.enabled"] = true,
      ["e.instr"] = 3,
      ["e.invert"] = false,
      ["e.offset"] = 16,
      ["e.pitch"] = 49.661417322835,
      ["e.pulses"] = 5,
      ["e.steps"] = 26,
      ["e.velocity"] = 35.275590551181,
      ["follow_instr"] = true,
      ["instr_idx"] = 3,
      ["name"] = "",
      ["phrase_idx"] = 0,
      ["tempo"] = 3,
      ["transpose"] = -17,
  },
},
data = {
},
events = {
},
options = {
 color = 0x505552,
},
callback = [[
-------------------------------------------------------------------------------
-- Euclidean Rhythms
-------------------------------------------------------------------------------

local generate = function(steps,pulses,offset,invert,pitch,velocity,column,instr_idx)
  local rslt = nil
  local step_size = steps/pulses
  local position = (xinc%steps)*(1/args.tempo)
  local pulses_table = {}
  for k = 0,(pulses-1) do
    local pulse = math.ceil(step_size * k)+offset
    table.insert(pulses_table,pulse % steps)
  end
  
  local do_output = table.find(pulses_table,position)
  if invert then 
    do_output = not do_output 
  end
  if do_output then
    --print(instr)
    instr_idx = args.follow_instr and args.instr_idx-1 or instr_idx
    xline.note_columns[column] = {
      note_value = pitch + args.transpose,
      volume_value = velocity == 0x80 and EMPTY_VOLUME_VALUE or velocity,
      instrument_value = instr_idx,
    }
  else
    xline.note_columns[column] = {}
  end
  if (args.phrase_idx == 0) then
    xline.effect_columns[1] = {
      number_string = "00",
      amount_value = 0
    }
  else
    xline.effect_columns[1] = {
      number_string = "0Z",
      amount_value = args.phrase_idx or 0,
    }
  end

end

local tabs = {"a","b","c","d","e"}
for k,v in ipairs(tabs) do

  if (args[v].enabled) then
    generate(args[v].steps,
      args[v].pulses,
      args[v].offset,
      args[v].invert,
      args[v].pitch,
      args[v].velocity,
      args[v].column,
      args[v].instr)
      
  end

end
]],
}